﻿using Dto;
using Model;

namespace ApiMappeur;

public static class UserMappeur
{
    public static UserDto ToDto(this User user)
    {
        return new UserDto
        {
            Id = user.Id,
            Username = user.Username,
            ProfilePicture = user.ProfilePicture,
            LastName = user.LastName,
            FirstName = user.FirstName,
            Email = user.Email,
            Password = user.MotDePasse,
            Sexe = user.Sexe,
            Lenght = user.Lenght,
            Weight = user.Weight,
            DateOfBirth = user.DateOfBirth,
            IsCoach = user.Role is Coach
        };
     
    }

    public static User ToModel(this UserDto userDto)
    {
        if (userDto.IsCoach)
        {
            return new User(
                userDto.Username,
                userDto.ProfilePicture,
                userDto.LastName,
                userDto.FirstName,
                userDto.Email,
                userDto.Password,
                userDto.Sexe,
                userDto.Lenght,
                userDto.Weight,
                userDto.DateOfBirth,
                new Coach()
            );
        }
        return new User(
            userDto.Username,
            userDto.ProfilePicture,
            userDto.LastName,
            userDto.FirstName,
            userDto.Email,
            userDto.Password,
            userDto.Sexe,
            userDto.Lenght,
            userDto.Weight,
            userDto.DateOfBirth,
            new Athlete());
    }
}